<script lang="ts">
    // This component handles the loading of the layout, depending
    // on default settings as well as the URL query string and hash
    // It displays messages while the layout is being loaded, or if
    // there is an error loading the layout. After the layout is properly
    // loaded, it renders the LayoutPanels component, which contains
    // the rest of the web app.
    import { useQuery } from "@sveltestack/svelte-query";
    import { fetch_json } from "./fetch_json.js";
    import { layout_file, layout } from "./svelte_stores/layout_store";
    import {
        set_ids_on_newly_loaded_layout,
        set_dataset_parameters,
    } from "./svelte_stores/catalog_and_info_store.js";
    import { global_zoom_detail_factor } from "./svelte_stores/zoom_range_store";

    import LayoutPanels from "./LayoutPanels.svelte";
    import InfoModal from "./InfoModal.svelte";

    import dayjs from "dayjs";
    import utc from "dayjs/plugin/utc";
    dayjs.extend(utc);

    $: layoutQuery = useQuery(["layout", $layout_file], fetch_json, {
        staleTime: 86400e3,
    });

    import {
        timeDomain,
        parse_time_or_duration_string,
    } from "./svelte_stores/timedomain_store.js";

    $: {
        if ($layoutQuery.isSuccess) {
            // Set layout store
            $layout = set_dataset_parameters(
                set_ids_on_newly_loaded_layout($layoutQuery.data),
            );

            // Set timedomain store
            let t0, t1;
            let urlParams = new URLSearchParams(
                window.location.hash.substring(1),
            );

            if (urlParams.has("start")) {
                let start = urlParams.get("start");
                t0 = parse_time_or_duration_string(start);
            } else {
                t0 = parse_time_or_duration_string(
                    $layoutQuery.data.default_zoom.tmin,
                );
            }
            if (urlParams.has("end")) {
                let end = urlParams.get("end");
                t1 = parse_time_or_duration_string(end);
            } else if (urlParams.has("stop")) {
                let end = urlParams.get("stop");
                t1 = parse_time_or_duration_string(end);
            } else {
                t1 = parse_time_or_duration_string(
                    $layoutQuery.data.default_zoom.tmax,
                );
            }
            // console.log(t0, t1);
            $timeDomain = [t0, t1];

            // Set default global zoom detail factor
            $global_zoom_detail_factor =
                $layoutQuery.data.options.zoom_detail_factor;
        }
    }
</script>

{#if $layoutQuery.isLoading}
    <div class="m-6">
        <span class="text-3xl font-thin dark:text-white"
            >Loading layout...</span>
    </div>
{:else if $layoutQuery.isError}
    <div class="w-full h-full m-6">
        <span class="text-3xl font-thin dark:text-white"
            >A problem occurred loading the <a
                href={$layout_file}
                style="text-decoration: underline;cursor: pointer;">layout</a
            >. Please try again later.</span>
    </div>
    <div class="w-full h-full m-6">Message: {$layoutQuery.error}</div>
{:else}
    <LayoutPanels />
{/if}
<InfoModal />

<style>
</style>
